# coding: utf-8

"""
    SpaceBlocks.Permissions.WebServices.Main.Api Management

    This is the management API.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from spaceblocks_permissions_server.models.resource_members import ResourceMembers
from spaceblocks_permissions_server.models.resource_parent import ResourceParent
from typing import Optional, Set
from typing_extensions import Self

class Resource(BaseModel):
    """
    Resource
    """ # noqa: E501
    id: Optional[StrictStr] = None
    resource_type_id: Optional[StrictStr] = Field(default=None, alias="resourceTypeId")
    tenant_id: Optional[StrictStr] = Field(default=None, alias="tenantId")
    parent: Optional[ResourceParent] = None
    is_inheritance_disabled: Optional[StrictBool] = Field(default=None, alias="isInheritanceDisabled")
    members: Optional[ResourceMembers] = None
    __properties: ClassVar[List[str]] = ["id", "resourceTypeId", "tenantId", "parent", "isInheritanceDisabled", "members"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Resource from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of parent
        if self.parent:
            _dict['parent'] = self.parent.to_dict()
        # override the default output from pydantic by calling `to_dict()` of members
        if self.members:
            _dict['members'] = self.members.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Resource from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "resourceTypeId": obj.get("resourceTypeId"),
            "tenantId": obj.get("tenantId"),
            "parent": ResourceParent.from_dict(obj["parent"]) if obj.get("parent") is not None else None,
            "isInheritanceDisabled": obj.get("isInheritanceDisabled"),
            "members": ResourceMembers.from_dict(obj["members"]) if obj.get("members") is not None else None
        })
        return _obj


